/* $Id: quick.c,v 1.3 2004/02/15 22:27:14 dw Exp $ */
/* Author Damian Weber http://www-crypto.htw-saarland.de 
 * License: http://www.gnu.org/licenses/gpl-2.0.html
 */

#include <stdio.h>

#include "sorting.h"

#undef DEBUG

/* Sedgewick's description in "Analysis of Algorithms" */
void quick_sort_r(int l, int r, int *a) 
{
	register int v,t,i,j;

	if (l<=r)
	{
		v=a[r];
		i=l-1;
		j=r;
		do
		{
			do { i++ ; } while (i<j && a[i]<v);
			do { j--; } while (i<j && a[j]>v);
			if (j>=0)
			{
				t=a[i];a[i]=a[j];a[j]=t;
			}
		}
		while (j>i);
		if (j>=0)
		{
			a[j]=a[i]; a[i]=a[r];a[r]=t;
		}
		quick_sort_r(l,i-1,a);
		quick_sort_r(i+1,r,a);
	}
}


/* quick sort for the a[0...n-1] */

void quick_sort(int n, int *a) 
{
	quick_sort_r(0,n-1,a);
}
